// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'bcParser.pas' rev: 3.00

#ifndef bcParserHPP
#define bcParserHPP
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Bcparser
{
//-- type declarations -------------------------------------------------------
typedef Extended NUMBER;

typedef Extended *PNUMBER;

class DELPHICLASS EbcParserError;
class PASCALIMPLEMENTATION EbcParserError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EbcParserError(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EbcParserError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EbcParserError(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EbcParserError(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EbcParserError(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EbcParserError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EbcParserError(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EbcParserError(int Ident, const System::TVarRec * Args, 
		const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext)
		 { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EbcParserError(void) { }
	
};

typedef Extended __fastcall (*TTwoParamFunc)(Extended x, Extended y);

typedef Extended __fastcall (*TOneParamFunc)(Extended x);

class DELPHICLASS TNode;
class PASCALIMPLEMENTATION TNode : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	virtual Extended __fastcall GetValue(void) = 0;
	virtual bool __fastcall IsUsed(void * Addr) = 0;
	virtual void __fastcall Optimize(void) = 0;
public:
	/* TObject.Create */ __fastcall TNode(void) : System::TObject() { }
	/* TObject.Destroy */ __fastcall virtual ~TNode(void) { }
	
};

class DELPHICLASS TbcParser;
class PASCALIMPLEMENTATION TbcParser : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	System::AnsiString FExpression;
	bool FDirty;
	TNode* FNode;
	Classes::TStringList* FVariables;
	Classes::TStringList* FOneParamFuncs;
	Classes::TStringList* FTwoParamFuncs;
	bool FOptimizationOn;
	
protected:
	System::AnsiString __fastcall GetExpression();
	void __fastcall SetExpression(const System::AnsiString str);
	void __fastcall SetX(const Extended x);
	Extended __fastcall GetX(void);
	void __fastcall SetY(const Extended y);
	Extended __fastcall GetY(void);
	int __fastcall FindLastOper(const System::AnsiString formula);
	bool __fastcall CreateParseTree(System::AnsiString &formula, TNode* &Node);
	bool __fastcall IsTwoParamFunc(const System::AnsiString formula, System::AnsiString &paramLeft, System::AnsiString 
		&paramRight, TTwoParamFunc &funcAddr, int CurrChar);
	bool __fastcall IsOneParamFunc(const System::AnsiString formula, System::AnsiString &param, TOneParamFunc 
		&funcAddr, int CurrChar);
	bool __fastcall IsVariable(const System::AnsiString varName);
	bool __fastcall IsOneParamFunction(const System::AnsiString funcName);
	bool __fastcall IsTwoParamFunction(const System::AnsiString funcName);
	void __fastcall Optimize(void);
	
public:
	__fastcall virtual TbcParser(Classes::TComponent* AOwner);
	__fastcall virtual ~TbcParser(void);
	virtual void __fastcall Parse(void);
	virtual Extended __fastcall Evaluate(void);
	virtual void __fastcall CreateVar(System::AnsiString name, Extended value);
	virtual void __fastcall CreateOneParamFunc(System::AnsiString name, TOneParamFunc procAddr);
	virtual void __fastcall CreateTwoParamFunc(System::AnsiString name, TTwoParamFunc procAddr);
	virtual void __fastcall CreateDefaultFuncs(void);
	virtual void __fastcall CreateDefaultVars(void);
	virtual void __fastcall AssignVar(System::AnsiString name, Extended val);
	virtual Extended __fastcall GetVar(System::AnsiString name);
	virtual void __fastcall DeleteVar(System::AnsiString name);
	virtual void __fastcall DeleteFunc(System::AnsiString name);
	virtual void __fastcall DeleteAllVars(void);
	virtual void __fastcall DeleteAllFuncs(void);
	virtual void __fastcall Randomize(void);
	virtual void __fastcall FreeParseTree(void);
	virtual bool __fastcall IsVariableUsed(const System::AnsiString varName);
	virtual bool __fastcall IsFunctionUsed(const System::AnsiString funcName);
	__property Extended Value = {read=Evaluate};
	__property Extended Variable[System::AnsiString name] = {read=GetVar, write=AssignVar};
	
__published:
	__property System::AnsiString Expression = {read=GetExpression, write=SetExpression};
	__property Extended X = {read=GetX, write=SetX};
	__property Extended Y = {read=GetY, write=SetY};
	__property bool OptimizationOn = {read=FOptimizationOn, write=FOptimizationOn, default=1};
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall Register(void);

}	/* namespace Bcparser */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Bcparser;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// bcParser
