// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'bcParser.pas' rev: 5.00

#ifndef bcParserHPP
#define bcParserHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Bcparser
{
//-- type declarations -------------------------------------------------------
typedef Extended NUMBER;

typedef Extended *PNUMBER;

class DELPHICLASS EbcParserError;
class PASCALIMPLEMENTATION EbcParserError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall EbcParserError(const AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EbcParserError(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EbcParserError(int Ident)/* overload */ : Sysutils::Exception(
		Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EbcParserError(int Ident, const System::TVarRec * Args
		, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EbcParserError(const AnsiString Msg, int AHelpContext)
		 : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EbcParserError(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EbcParserError(int Ident, int AHelpContext)/* overload */
		 : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EbcParserError(System::PResStringRec ResStringRec
		, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(
		ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EbcParserError(void) { }
	#pragma option pop
	
};


typedef Extended __fastcall (*TTwoParamFunc)(Extended x, Extended y);

typedef Extended __fastcall (*TOneParamFunc)(Extended x);

class DELPHICLASS TNode;
class PASCALIMPLEMENTATION TNode : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	virtual Extended __fastcall GetValue(void) = 0 ;
	virtual bool __fastcall IsUsed(void * Addr) = 0 ;
	virtual void __fastcall Optimize(void) = 0 ;
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TNode(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TNode(void) { }
	#pragma option pop
	
};


class DELPHICLASS TbcParser;
class PASCALIMPLEMENTATION TbcParser : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	AnsiString FExpression;
	bool FDirty;
	TNode* FNode;
	Classes::TStringList* FVariables;
	Classes::TStringList* FOneParamFuncs;
	Classes::TStringList* FTwoParamFuncs;
	bool FOptimizationOn;
	
protected:
	AnsiString __fastcall GetExpression();
	void __fastcall SetExpression(const AnsiString str);
	void __fastcall SetX(const Extended x);
	Extended __fastcall GetX(void);
	void __fastcall SetY(const Extended y);
	Extended __fastcall GetY(void);
	int __fastcall FindLastOper(const AnsiString formula);
	bool __fastcall CreateParseTree(AnsiString &formula, TNode* &Node);
	bool __fastcall IsTwoParamFunc(const AnsiString formula, AnsiString &paramLeft, AnsiString &paramRight
		, TTwoParamFunc &funcAddr, int CurrChar);
	bool __fastcall IsOneParamFunc(const AnsiString formula, AnsiString &param, TOneParamFunc &funcAddr
		, int CurrChar);
	bool __fastcall IsVariable(const AnsiString varName);
	bool __fastcall IsOneParamFunction(const AnsiString funcName);
	bool __fastcall IsTwoParamFunction(const AnsiString funcName);
	void __fastcall Optimize(void);
	
public:
	__fastcall virtual TbcParser(Classes::TComponent* AOwner);
	__fastcall virtual ~TbcParser(void);
	virtual void __fastcall Parse(void);
	virtual Extended __fastcall Evaluate(void);
	virtual void __fastcall CreateVar(AnsiString name, Extended value);
	virtual void __fastcall CreateOneParamFunc(AnsiString name, TOneParamFunc procAddr);
	virtual void __fastcall CreateTwoParamFunc(AnsiString name, TTwoParamFunc procAddr);
	virtual void __fastcall CreateDefaultFuncs(void);
	virtual void __fastcall CreateDefaultVars(void);
	virtual void __fastcall AssignVar(AnsiString name, Extended val);
	virtual Extended __fastcall GetVar(AnsiString name);
	virtual void __fastcall DeleteVar(AnsiString name);
	virtual void __fastcall DeleteFunc(AnsiString name);
	virtual void __fastcall DeleteAllVars(void);
	virtual void __fastcall DeleteAllFuncs(void);
	virtual void __fastcall Randomize(void);
	virtual void __fastcall FreeParseTree(void);
	virtual bool __fastcall IsVariableUsed(const AnsiString varName);
	virtual bool __fastcall IsFunctionUsed(const AnsiString funcName);
	__property Extended Value = {read=Evaluate};
	__property Extended Variable[AnsiString name] = {read=GetVar, write=AssignVar};
	
__published:
	__property AnsiString Expression = {read=GetExpression, write=SetExpression};
	__property Extended X = {read=GetX, write=SetX};
	__property Extended Y = {read=GetY, write=SetY};
	__property bool OptimizationOn = {read=FOptimizationOn, write=FOptimizationOn, default=1};
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall Register(void);

}	/* namespace Bcparser */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Bcparser;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// bcParser
